*** transfor.c	2004/05/07 19:46:16	1.1
--- transfor.c	2005/01/16 20:25:17
***************
*** 2989,2994 ****
--- 3152,3159 ----
          } else Zoom = (DialValue[DialZoom]*MaxZoom) + 1.0;
  
          Scale = Zoom*DScale*Range;
+         LScale = (Long)(Scale*256);
+         iProbeRad = (int)(Scale*ProbeRadius);
          ImageSize = (int)(Scale*WorldSize);
          if( ImageSize < 2 )
          {   ImageRadius = 1;
***************
*** 3044,3051 ****
              {   x = ptr->xorg + ptr->fxorg - CenX; 
                  y = ptr->yorg + ptr->fyorg - CenY; 
                  z = ptr->zorg + ptr->fzorg - CenZ;
!                 ptr->y = (int)(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
!                 ptr->z = (int)(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
              }
              break;
  
--- 3209,3216 ----
              {   x = ptr->xorg + ptr->fxorg - CenX; 
                  y = ptr->yorg + ptr->fyorg - CenY; 
                  z = ptr->zorg + ptr->fzorg - CenZ;
!                 ptr->y = (int)rint(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
!                 ptr->z = (int)rint(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
              }
              break;
  
***************
*** 3054,3061 ****
              {   x = ptr->xorg + ptr->fxorg - CenX; 
                  y = ptr->yorg + ptr->fyorg - CenY; 
                  z = ptr->zorg + ptr->fzorg - CenZ;
!                 ptr->x = (int)(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                 ptr->z = (int)(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
              }
              break;
  
--- 3219,3226 ----
              {   x = ptr->xorg + ptr->fxorg - CenX; 
                  y = ptr->yorg + ptr->fyorg - CenY; 
                  z = ptr->zorg + ptr->fzorg - CenZ;
!                 ptr->x = (int)rint(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                 ptr->z = (int)rint(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
              }
              break;
  
***************
*** 3064,3088 ****
              {   x = ptr->xorg + ptr->fxorg - CenX; 
                  y = ptr->yorg + ptr->fyorg - CenY; 
                  z = ptr->zorg + ptr->fzorg - CenZ;
!                 ptr->x = (int)(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                 ptr->y = (int)(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
              }
              break;
  
          default:
              /* This condition scales atomic radii! */
!             if( (DrawAtoms || DrawStars) && (ReDrawFlag&(RFMagnify | RFZoom)) )
              {   ForEachAtom 
                  {   x = ptr->xorg + ptr->fxorg - CenX; 
                      y = ptr->yorg + ptr->fyorg - CenY; 
                      z = ptr->zorg + ptr->fzorg - CenZ;
!                     ptr->x = (int)(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                     ptr->y = (int)(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
!                     ptr->z = (int)(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
!                     if( ptr->flag&SphereFlag )
                      {   ptr->irad = (int)(Scale*(Real)(ptr->radius));
                          if( ptr->irad>MaxAtomRadius )
                              MaxAtomRadius = ptr->irad;
                      }
                  }
              } else
--- 3229,3259 ----
              {   x = ptr->xorg + ptr->fxorg - CenX; 
                  y = ptr->yorg + ptr->fyorg - CenY; 
                  z = ptr->zorg + ptr->fzorg - CenZ;
!                 ptr->x = (int)rint(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                 ptr->y = (int)rint(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
              }
              break;
  
          default:
              /* This condition scales atomic radii! */
!             if( (DrawAtoms || DrawStars || DrawSurf) &&
!                 (ReDrawFlag&(RFMagnify | RFZoom)) )
              {   ForEachAtom 
                  {   x = ptr->xorg + ptr->fxorg - CenX; 
                      y = ptr->yorg + ptr->fyorg - CenY; 
                      z = ptr->zorg + ptr->fzorg - CenZ;
!                     ptr->x = (int)rint(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                     ptr->y = (int)rint(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
!                     ptr->z = (int)rint(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
!                     if( ptr->flag&(SphereFlag|StarFlag|TouchFlag|ExpandFlag) )
                      {   ptr->irad = (int)(Scale*(Real)(ptr->radius));
                          if( ptr->irad>MaxAtomRadius )
                              MaxAtomRadius = ptr->irad;
+                         if (ptr->flag&ExpandFlag)
+                         {
+                            if ((ptr->irad)+iProbeRad > MaxAtomRadius )
+                              MaxAtomRadius = (ptr->irad)+iProbeRad;
+                         }
                      }
                  }
              } else
***************
*** 3090,3126 ****
                  {   x = ptr->xorg + ptr->fxorg - CenX; 
                      y = ptr->yorg + ptr->fyorg - CenY; 
                      z = ptr->zorg + ptr->fzorg - CenZ;
!                     ptr->x = (int)(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                     ptr->y = (int)(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
!                     ptr->z = (int)(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
                  }
  
              if( ReDrawFlag & ( RFMagnify | RFZoom ) )
              {   if( DrawBonds )
                      ForEachBond
                          if( bptr->flag&CylinderFlag )
!                         {   bptr->irad = (int)(Scale*(Real)(bptr->radius));
!                             bptr->iarad = (int)(Scale*(Real)(bptr->aradius));
                              if( bptr->irad>MaxBondRadius )
                              MaxBondRadius = bptr->irad;
                          }
  
                  for( hptr=Database->hlist; hptr; hptr=hptr->hnext )
  		    if( hptr->flag&CylinderFlag ) {
!                         hptr->irad = (int)(Scale*(Real)(hptr->radius));
!                         hptr->iarad = (int)(Scale*(Real)(hptr->aradius));
                      }
  
                  for( hptr=Database->slist; hptr; hptr=hptr->hnext )
  		    if( hptr->flag&CylinderFlag ) {
!                         hptr->irad = (int)(Scale*(Real)(hptr->radius));
!                         hptr->iarad = (int)(Scale*(Real)(hptr->aradius));
  		    }
  
                  ForEachBack
  		    if( bptr->flag&CylinderFlag ) {
!                         bptr->irad = (int)(Scale*(Real)(bptr->radius));
!                         bptr->iarad = (int)(Scale*(Real)(bptr->aradius));
                      }
              }
      }
--- 3261,3297 ----
                  {   x = ptr->xorg + ptr->fxorg - CenX; 
                      y = ptr->yorg + ptr->fyorg - CenY; 
                      z = ptr->zorg + ptr->fzorg - CenZ;
!                     ptr->x = (int)rint(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset;
!                     ptr->y = (int)rint(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset;
!                     ptr->z = (int)rint(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset;
                  }
  
              if( ReDrawFlag & ( RFMagnify | RFZoom ) )
              {   if( DrawBonds )
                      ForEachBond
                          if( bptr->flag&CylinderFlag )
!                         {   bptr->irad = (int)rint(Scale*(Real)(bptr->radius));
!                             bptr->iarad = (int)rint(Scale*(Real)(bptr->aradius));
                              if( bptr->irad>MaxBondRadius )
                              MaxBondRadius = bptr->irad;
                          }
  
                  for( hptr=Database->hlist; hptr; hptr=hptr->hnext )
  		    if( hptr->flag&CylinderFlag ) {
!                         hptr->irad = (int)rint(Scale*(Real)(hptr->radius));
!                         hptr->iarad = (int)rint(Scale*(Real)(hptr->aradius));
                      }
  
                  for( hptr=Database->slist; hptr; hptr=hptr->hnext )
  		    if( hptr->flag&CylinderFlag ) {
!                         hptr->irad = (int)rint(Scale*(Real)(hptr->radius));
!                         hptr->iarad = (int)rint(Scale*(Real)(hptr->aradius));
  		    }
  
                  ForEachBack
  		    if( bptr->flag&CylinderFlag ) {
!                         bptr->irad = (int)rint(Scale*(Real)(bptr->radius));
!                         bptr->iarad = (int)rint(Scale*(Real)(bptr->aradius));
                      }
              }
      }
*** transfor.h	2004/05/07 19:46:16	1.1
--- transfor.h	2005/01/16 20:25:16
***************
*** 210,215 ****
--- 213,219 ----
  int UseDotColPot;
  
  Real Scale,MaxZoom;
+ Long LScale;
  Real DScale,IScale;
  Long SideLen,Offset;
  Card WorldRadius,WorldSize,LocalRadius;
***************
*** 221,226 ****
--- 225,231 ----
  int DrawAtoms,MaxAtomRadius;
  int DrawBonds,MaxBondRadius;
  int DrawStars;
+ int DrawSurf;
  int DrawRibbon;
  int ZoneBoth;
  int ModelInclude;
***************
*** 259,264 ****
--- 264,270 ----
  extern int UseDotColPot;
  
  extern Real Scale,MaxZoom;
+ extern Long LScale;
  extern Real DScale,IScale;
  extern Long SideLen,Offset;
  extern Card WorldRadius,WorldSize,LocalRadius;
***************
*** 270,275 ****
--- 276,282 ----
  extern int DrawAtoms,MaxAtomRadius;
  extern int DrawBonds,MaxBondRadius;
  extern int DrawStars;
+ extern int DrawSurf;
  extern int DrawRibbon;
  extern int ZoneBoth;
  extern int ModelInclude;
*** x11win.c	2004/05/07 19:46:16	1.1
--- x11win.c	2005/01/16 20:25:17
***************
*** 186,192 ****
      { &(MolNStr[4]),                            0x01,  0, 
          &MolNLen[4],            &MoleculeIndex, 4 } };
  
! static MenuItem DisMenu[8] = {
      { &MsgStrs[StrMWirefr] /* "Wireframe"    */,     0x11,  &MsgAuxl[StrMWirefr],
          &MsgLens[StrMWirefr],    NULL, 0     },
      { &MsgStrs[StrMBackbn] /* "Backbone"     */,     0x11,  &MsgAuxl[StrMBackbn],
--- 189,195 ----
      { &(MolNStr[4]),                            0x01,  0, 
          &MolNLen[4],            &MoleculeIndex, 4 } };
  
! static MenuItem DisMenu[9] = {
      { &MsgStrs[StrMWirefr] /* "Wireframe"    */,     0x11,  &MsgAuxl[StrMWirefr],
          &MsgLens[StrMWirefr],    NULL, 0     },
      { &MsgStrs[StrMBackbn] /* "Backbone"     */,     0x11,  &MsgAuxl[StrMBackbn],
***************
*** 202,208 ****
      { &MsgStrs[StrMStrands]/* "Strands"      */,     0x11,  &MsgAuxl[StrMStrands],
          &MsgLens[StrMStrands],   NULL, 0     },
      { &MsgStrs[StrMCartoon]/* "Cartoons"     */,     0x11,  &MsgAuxl[StrMCartoon],
!         &MsgLens[StrMCartoon],   NULL, 0     }};
  
  
  static MenuItem ColMenu[10] = {
--- 205,214 ----
      { &MsgStrs[StrMStrands]/* "Strands"      */,     0x11,  &MsgAuxl[StrMStrands],
          &MsgLens[StrMStrands],   NULL, 0     },
      { &MsgStrs[StrMCartoon]/* "Cartoons"     */,     0x11,  &MsgAuxl[StrMCartoon],
!         &MsgLens[StrMCartoon],   NULL, 0     },
!     { &MsgStrs[StrMMolSurf]/* "Molecular Surface"    */,     0x11,  &MsgAuxl[StrMMolSurf],
!         &MsgLens[StrMMolSurf],   NULL, 0     }};
!  
  
  
  static MenuItem ColMenu[10] = {
***************
*** 308,314 ****
  static BarItem MenuBar[MenuBarMax] = { 
      { FilMenu,  &MsgStrs[StrMFile]    /* "File"     */,  5, 0x01,&MsgAuxl[StrMFile],
          &MsgLens[StrMFile], &NumMolecules},
!     { DisMenu,  &MsgStrs[StrMDisplay] /* "Display"  */,  8, 0x01,&MsgAuxl[StrMDisplay],
          &MsgLens[StrMDisplay], NULL },
      { ColMenu,  &MsgStrs[StrMColour]  /* "Colours"  */, 10, 0x01,&MsgAuxl[StrMColour],
          &MsgLens[StrMColour], NULL },
--- 314,320 ----
  static BarItem MenuBar[MenuBarMax] = { 
      { FilMenu,  &MsgStrs[StrMFile]    /* "File"     */,  5, 0x01,&MsgAuxl[StrMFile],
          &MsgLens[StrMFile], &NumMolecules},
!     { DisMenu,  &MsgStrs[StrMDisplay] /* "Display"  */,  9, 0x01,&MsgAuxl[StrMDisplay],
          &MsgLens[StrMDisplay], NULL },
      { ColMenu,  &MsgStrs[StrMColour]  /* "Colours"  */, 10, 0x01,&MsgAuxl[StrMColour],
          &MsgLens[StrMColour], NULL },
